#define alive 1
#define dead 0
/*-- CARPET-generated code below --*/


/*
 CARPET #include
*/
#include "mod2.h"
#include "cpt_ccdefs.h"

/*
 CARPET Global variables
*/
extern int cpt_generation;
extern char in_steering;
extern int cpt_x, cpt_y, cpt_z;

#ifdef EVEN_DECOMP
#else
extern int CPT_F_X[CPT_NPROCS][NFOLDS], CPT_S_X[CPT_NPROCS][NFOLDS];
#endif /* EVEN_DECOMP */

float cpt_globpar[NumOfGlobPar] = 
  {  0.0  };

const float *cpt_globpar_ro = cpt_globpar;

#include <stddef.h>
const size_t cpt_state_size[NumOfStates+1] = 
  { sizeof(unsigned char  ), 0 };

const char *cpt_state_name[NumOfStates] = {"stato"};

#ifdef EVEN_DECOMP
#else
static int cpt_Neumann[5];
#endif /* EVEN_DECOMP */

void cpt_hook_init( void )
{
    extern int cpt_dimx, cpt_dimy, cpt_dimz;

    cpt_dimx = CPT_X;
    cpt_dimy = CPT_Y;
    cpt_dimz = CPT_Z;

#ifdef EVEN_DECOMP
#else
    cpt_Neumann[0] = (0 + (-1*CPT_X) + (0) );
    cpt_Neumann[1] = (0 + (0*CPT_X) + (-1) );
    cpt_Neumann[2] = (0 + (1*CPT_X) + (0) );
    cpt_Neumann[3] = (0 + (0*CPT_X) + (1) );
    cpt_Neumann[4] = 0;
#endif /* EVEN_DECOMP */

    return;
}


void cpt_hook_finalize( void )
{
    return;
}


void cpt_set_state( CptCell *cell, int stateid, void *value, int size )
{
    register int i;

    char *cp = (char *) value;

    switch (stateid)
    {
        case 0:
            for (i=0; i<size; i++, cell++, cp+=cpt_state_size[stateid])
                cell->stato = *((unsigned char  *)cp);
            break;
        default: break;
    }
    return;
}


void cpt_get_state( CptCell *cell, int stateid, void *value, int size )
{
    register int i;
    char *cp = (char *) value;

    switch (stateid)
    {
        case 0:
            for (i=0; i<size; i++, cell++, cp+=cpt_state_size[stateid])
                *((unsigned char  *)cp) = cell->stato;
            break;
        default: break;
    }
    return;
}

/* CAMELot-generated function pointer array for XDR */
#include <rpc/rpc.h>

bool_t (*cpt_state_XDRfn[NumOfStates]) (XDR *, void *) = {
	 (bool_t (*) (XDR *, void *)) xdr_u_char
	};

/* CAMELot-generated function for MPI defns */
#ifdef CPT_PARALLEL_MPI
#include <mpi.h>

MPI_Datatype cpt_state_mpidt[NumOfStates+1] = { MPI_UNSIGNED_CHAR, MPI_UB };
void cpt_mpi_type_cell( MPI_Datatype *dt )
{

#ifdef HOMOGENEOUS

    MPI_Type_contiguous (sizeof (CptCell), MPI_CHAR, dt);

#else /* HOMOGENEOUS */

    int count[1+1] = { 1, 1 };
    MPI_Aint disp[1+1], base;
    MPI_Datatype type[1+1] = { MPI_UNSIGNED_CHAR, MPI_UB };

    CptCell sample[2];
    int i;

    MPI_Address( &sample[0], &base );
    disp[0] = (MPI_Aint) 0;
    MPI_Address( &sample[1], &disp[1] );
    for (i=1; i<1+1; i++)
        disp[i] -= base;

    MPI_Type_struct( 2, count, disp, type, dt );

#endif /* HOMOGENEOUS */

    MPI_Type_commit( dt );

    return;
}
#endif /* def CPT_PARALLEL_MPI*/


/*
 CARPET `step' global variable
*/

#define step    (cpt_generation)

/*
 CARPET coordinate global variable
*/
#define GetX   (cpt_x)
#define GetY   (cpt_y)
#define GetZ   (cpt_z)

/*
 CA Engine Dimensions and Configuration
*/
#define DimX   (DIMX)
#define DimY   (DIMY)
#define DimZ   (DIMZ)
#define NProcs   (CPT_NPROCS)
#define NFolds   (NFOLDS)

/*
 CARPET random functions
*/
#include <stdlib.h>
#define random(r)     (rand() % (r))
#define randomise     randomize
#define randomize     cpt_randomize
#define srandom       cpt_srandom

/*
 CARPET global parameters
*/

/*
 CARPET cell substate definitions
*/
#define cell_stato  (actv_cell->stato)

/*
 CARPET neighbourhood substate definitions
*/
#define Nord_stato  ((actv_cell + (-1*CPT_X) + (0) )->stato)
#define Ovest_stato  ((actv_cell + (0*CPT_X) + (-1) )->stato)
#define Sud_stato  ((actv_cell + (1*CPT_X) + (0) )->stato)
#define Est_stato  ((actv_cell + (0*CPT_X) + (1) )->stato)

#ifdef EVEN_DECOMP
static int cpt_Neumann[] = { 
    (0 + (-1*CPT_X) + (0) ),
    (0 + (0*CPT_X) + (-1) ),
    (0 + (1*CPT_X) + (0) ),
    (0 + (0*CPT_X) + (1) ),
    0 };
#endif /* EVEN_DECOMP */
#define Neumann (actv_cell + cpt_Neumann


/* CARPET active region control */

#define CPT_THRESH_COND (0)

int cpt_thresh (CptCell *actv_cell) {
  return CPT_THRESH_COND;
}

const int cpt_determin = 0;

/*
 CARPET transition state function 
*/
void cpt_func( CptCell *new_actv_cell, CptCell *new_noactv_cell )
{

/*
 Start of user-defined variable
*/
#line 15

    int i;
    int sum;
  
/*
 End of user-defined variable
*/

#ifdef CAMEL_INDEXING_USED

/*
 CAMEL neighbourhood variable definition
*/
unsigned char    Neumann_stato[4];

/*
actv_cell and noactv_cell initialisation
*/

actv_cell = new_actv_cell;
noactv_cell = new_noactv_cell;

/*
 CAMEL neighbourhood variable setting
*/
Neumann_stato[0] = Nord_stato;
Neumann_stato[1] = Ovest_stato;
Neumann_stato[2] = Sud_stato;
Neumann_stato[3] = Est_stato;

#else /*def !CAMEL_INDEXING_USED*/

/*
actv_cell and noactv_cell initialisation
*/

actv_cell = new_actv_cell;
noactv_cell = new_noactv_cell;

#endif /*def CAMEL_INDEXING_USED*/

/*
Start of user-defined code
*/
#line 18

    sum = 0;
    for( i=0 ; i<4; i++)
        sum = sum + Neumann[i])->stato;
    sum=sum % 2;
    if ( sum==1)
         noactv_cell->stato = ( alive);
    else
         noactv_cell->stato = ( dead);
  }
/*
 End of user-defined code
*/

#include "constants.h"

req_code cpt_steering (CptCell *data_ptr) {

/* no steering code; dummy for macrocell.c */

  return (NULL_CODE);	/* Stop warning */

}
/*
 End of steering code
*/
